<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for PromotionCodeSearchBasic StructType
 * @subpackage Structs
 */
class PromotionCodeSearchBasic extends SearchRecordBasic
{
    /**
     * The applyDiscountTo
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\SearchEnumMultiSelectField
     */
    public $applyDiscountTo;
    /**
     * The code
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\SearchStringField
     */
    public $code;
    /**
     * The description
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\SearchStringField
     */
    public $description;
    /**
     * The discount
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\SearchMultiSelectField
     */
    public $discount;
    /**
     * The endDate
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\SearchDateField
     */
    public $endDate;
    /**
     * The externalId
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\SearchMultiSelectField
     */
    public $externalId;
    /**
     * The externalIdString
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\SearchStringField
     */
    public $externalIdString;
    /**
     * The freeShipItem
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\SearchMultiSelectField
     */
    public $freeShipItem;
    /**
     * The internalId
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\SearchMultiSelectField
     */
    public $internalId;
    /**
     * The internalIdNumber
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\SearchLongField
     */
    public $internalIdNumber;
    /**
     * The isInactive
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\SearchBooleanField
     */
    public $isInactive;
    /**
     * The isPublic
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\SearchBooleanField
     */
    public $isPublic;
    /**
     * The item
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\SearchMultiSelectField
     */
    public $item;
    /**
     * The location
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\SearchMultiSelectField
     */
    public $location;
    /**
     * The name
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\SearchStringField
     */
    public $name;
    /**
     * The partner
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\SearchMultiSelectField
     */
    public $partner;
    /**
     * The startDate
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\SearchDateField
     */
    public $startDate;
    /**
     * The customFieldList
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\SearchCustomFieldList
     */
    public $customFieldList;
    /**
     * Constructor method for PromotionCodeSearchBasic
     * @uses PromotionCodeSearchBasic::setApplyDiscountTo()
     * @uses PromotionCodeSearchBasic::setCode()
     * @uses PromotionCodeSearchBasic::setDescription()
     * @uses PromotionCodeSearchBasic::setDiscount()
     * @uses PromotionCodeSearchBasic::setEndDate()
     * @uses PromotionCodeSearchBasic::setExternalId()
     * @uses PromotionCodeSearchBasic::setExternalIdString()
     * @uses PromotionCodeSearchBasic::setFreeShipItem()
     * @uses PromotionCodeSearchBasic::setInternalId()
     * @uses PromotionCodeSearchBasic::setInternalIdNumber()
     * @uses PromotionCodeSearchBasic::setIsInactive()
     * @uses PromotionCodeSearchBasic::setIsPublic()
     * @uses PromotionCodeSearchBasic::setItem()
     * @uses PromotionCodeSearchBasic::setLocation()
     * @uses PromotionCodeSearchBasic::setName()
     * @uses PromotionCodeSearchBasic::setPartner()
     * @uses PromotionCodeSearchBasic::setStartDate()
     * @uses PromotionCodeSearchBasic::setCustomFieldList()
     * @param \StructType\SearchEnumMultiSelectField $applyDiscountTo
     * @param \StructType\SearchStringField $code
     * @param \StructType\SearchStringField $description
     * @param \StructType\SearchMultiSelectField $discount
     * @param \StructType\SearchDateField $endDate
     * @param \StructType\SearchMultiSelectField $externalId
     * @param \StructType\SearchStringField $externalIdString
     * @param \StructType\SearchMultiSelectField $freeShipItem
     * @param \StructType\SearchMultiSelectField $internalId
     * @param \StructType\SearchLongField $internalIdNumber
     * @param \StructType\SearchBooleanField $isInactive
     * @param \StructType\SearchBooleanField $isPublic
     * @param \StructType\SearchMultiSelectField $item
     * @param \StructType\SearchMultiSelectField $location
     * @param \StructType\SearchStringField $name
     * @param \StructType\SearchMultiSelectField $partner
     * @param \StructType\SearchDateField $startDate
     * @param \StructType\SearchCustomFieldList $customFieldList
     */
    public function __construct(\StructType\SearchEnumMultiSelectField $applyDiscountTo = null, \StructType\SearchStringField $code = null, \StructType\SearchStringField $description = null, \StructType\SearchMultiSelectField $discount = null, \StructType\SearchDateField $endDate = null, \StructType\SearchMultiSelectField $externalId = null, \StructType\SearchStringField $externalIdString = null, \StructType\SearchMultiSelectField $freeShipItem = null, \StructType\SearchMultiSelectField $internalId = null, \StructType\SearchLongField $internalIdNumber = null, \StructType\SearchBooleanField $isInactive = null, \StructType\SearchBooleanField $isPublic = null, \StructType\SearchMultiSelectField $item = null, \StructType\SearchMultiSelectField $location = null, \StructType\SearchStringField $name = null, \StructType\SearchMultiSelectField $partner = null, \StructType\SearchDateField $startDate = null, \StructType\SearchCustomFieldList $customFieldList = null)
    {
        $this
            ->setApplyDiscountTo($applyDiscountTo)
            ->setCode($code)
            ->setDescription($description)
            ->setDiscount($discount)
            ->setEndDate($endDate)
            ->setExternalId($externalId)
            ->setExternalIdString($externalIdString)
            ->setFreeShipItem($freeShipItem)
            ->setInternalId($internalId)
            ->setInternalIdNumber($internalIdNumber)
            ->setIsInactive($isInactive)
            ->setIsPublic($isPublic)
            ->setItem($item)
            ->setLocation($location)
            ->setName($name)
            ->setPartner($partner)
            ->setStartDate($startDate)
            ->setCustomFieldList($customFieldList);
    }
    /**
     * Get applyDiscountTo value
     * @return \StructType\SearchEnumMultiSelectField|null
     */
    public function getApplyDiscountTo()
    {
        return $this->applyDiscountTo;
    }
    /**
     * Set applyDiscountTo value
     * @param \StructType\SearchEnumMultiSelectField $applyDiscountTo
     * @return \StructType\PromotionCodeSearchBasic
     */
    public function setApplyDiscountTo(\StructType\SearchEnumMultiSelectField $applyDiscountTo = null)
    {
        $this->applyDiscountTo = $applyDiscountTo;
        return $this;
    }
    /**
     * Get code value
     * @return \StructType\SearchStringField|null
     */
    public function getCode()
    {
        return $this->code;
    }
    /**
     * Set code value
     * @param \StructType\SearchStringField $code
     * @return \StructType\PromotionCodeSearchBasic
     */
    public function setCode(\StructType\SearchStringField $code = null)
    {
        $this->code = $code;
        return $this;
    }
    /**
     * Get description value
     * @return \StructType\SearchStringField|null
     */
    public function getDescription()
    {
        return $this->description;
    }
    /**
     * Set description value
     * @param \StructType\SearchStringField $description
     * @return \StructType\PromotionCodeSearchBasic
     */
    public function setDescription(\StructType\SearchStringField $description = null)
    {
        $this->description = $description;
        return $this;
    }
    /**
     * Get discount value
     * @return \StructType\SearchMultiSelectField|null
     */
    public function getDiscount()
    {
        return $this->discount;
    }
    /**
     * Set discount value
     * @param \StructType\SearchMultiSelectField $discount
     * @return \StructType\PromotionCodeSearchBasic
     */
    public function setDiscount(\StructType\SearchMultiSelectField $discount = null)
    {
        $this->discount = $discount;
        return $this;
    }
    /**
     * Get endDate value
     * @return \StructType\SearchDateField|null
     */
    public function getEndDate()
    {
        return $this->endDate;
    }
    /**
     * Set endDate value
     * @param \StructType\SearchDateField $endDate
     * @return \StructType\PromotionCodeSearchBasic
     */
    public function setEndDate(\StructType\SearchDateField $endDate = null)
    {
        $this->endDate = $endDate;
        return $this;
    }
    /**
     * Get externalId value
     * @return \StructType\SearchMultiSelectField|null
     */
    public function getExternalId()
    {
        return $this->externalId;
    }
    /**
     * Set externalId value
     * @param \StructType\SearchMultiSelectField $externalId
     * @return \StructType\PromotionCodeSearchBasic
     */
    public function setExternalId(\StructType\SearchMultiSelectField $externalId = null)
    {
        $this->externalId = $externalId;
        return $this;
    }
    /**
     * Get externalIdString value
     * @return \StructType\SearchStringField|null
     */
    public function getExternalIdString()
    {
        return $this->externalIdString;
    }
    /**
     * Set externalIdString value
     * @param \StructType\SearchStringField $externalIdString
     * @return \StructType\PromotionCodeSearchBasic
     */
    public function setExternalIdString(\StructType\SearchStringField $externalIdString = null)
    {
        $this->externalIdString = $externalIdString;
        return $this;
    }
    /**
     * Get freeShipItem value
     * @return \StructType\SearchMultiSelectField|null
     */
    public function getFreeShipItem()
    {
        return $this->freeShipItem;
    }
    /**
     * Set freeShipItem value
     * @param \StructType\SearchMultiSelectField $freeShipItem
     * @return \StructType\PromotionCodeSearchBasic
     */
    public function setFreeShipItem(\StructType\SearchMultiSelectField $freeShipItem = null)
    {
        $this->freeShipItem = $freeShipItem;
        return $this;
    }
    /**
     * Get internalId value
     * @return \StructType\SearchMultiSelectField|null
     */
    public function getInternalId()
    {
        return $this->internalId;
    }
    /**
     * Set internalId value
     * @param \StructType\SearchMultiSelectField $internalId
     * @return \StructType\PromotionCodeSearchBasic
     */
    public function setInternalId(\StructType\SearchMultiSelectField $internalId = null)
    {
        $this->internalId = $internalId;
        return $this;
    }
    /**
     * Get internalIdNumber value
     * @return \StructType\SearchLongField|null
     */
    public function getInternalIdNumber()
    {
        return $this->internalIdNumber;
    }
    /**
     * Set internalIdNumber value
     * @param \StructType\SearchLongField $internalIdNumber
     * @return \StructType\PromotionCodeSearchBasic
     */
    public function setInternalIdNumber(\StructType\SearchLongField $internalIdNumber = null)
    {
        $this->internalIdNumber = $internalIdNumber;
        return $this;
    }
    /**
     * Get isInactive value
     * @return \StructType\SearchBooleanField|null
     */
    public function getIsInactive()
    {
        return $this->isInactive;
    }
    /**
     * Set isInactive value
     * @param \StructType\SearchBooleanField $isInactive
     * @return \StructType\PromotionCodeSearchBasic
     */
    public function setIsInactive(\StructType\SearchBooleanField $isInactive = null)
    {
        $this->isInactive = $isInactive;
        return $this;
    }
    /**
     * Get isPublic value
     * @return \StructType\SearchBooleanField|null
     */
    public function getIsPublic()
    {
        return $this->isPublic;
    }
    /**
     * Set isPublic value
     * @param \StructType\SearchBooleanField $isPublic
     * @return \StructType\PromotionCodeSearchBasic
     */
    public function setIsPublic(\StructType\SearchBooleanField $isPublic = null)
    {
        $this->isPublic = $isPublic;
        return $this;
    }
    /**
     * Get item value
     * @return \StructType\SearchMultiSelectField|null
     */
    public function getItem()
    {
        return $this->item;
    }
    /**
     * Set item value
     * @param \StructType\SearchMultiSelectField $item
     * @return \StructType\PromotionCodeSearchBasic
     */
    public function setItem(\StructType\SearchMultiSelectField $item = null)
    {
        $this->item = $item;
        return $this;
    }
    /**
     * Get location value
     * @return \StructType\SearchMultiSelectField|null
     */
    public function getLocation()
    {
        return $this->location;
    }
    /**
     * Set location value
     * @param \StructType\SearchMultiSelectField $location
     * @return \StructType\PromotionCodeSearchBasic
     */
    public function setLocation(\StructType\SearchMultiSelectField $location = null)
    {
        $this->location = $location;
        return $this;
    }
    /**
     * Get name value
     * @return \StructType\SearchStringField|null
     */
    public function getName()
    {
        return $this->name;
    }
    /**
     * Set name value
     * @param \StructType\SearchStringField $name
     * @return \StructType\PromotionCodeSearchBasic
     */
    public function setName(\StructType\SearchStringField $name = null)
    {
        $this->name = $name;
        return $this;
    }
    /**
     * Get partner value
     * @return \StructType\SearchMultiSelectField|null
     */
    public function getPartner()
    {
        return $this->partner;
    }
    /**
     * Set partner value
     * @param \StructType\SearchMultiSelectField $partner
     * @return \StructType\PromotionCodeSearchBasic
     */
    public function setPartner(\StructType\SearchMultiSelectField $partner = null)
    {
        $this->partner = $partner;
        return $this;
    }
    /**
     * Get startDate value
     * @return \StructType\SearchDateField|null
     */
    public function getStartDate()
    {
        return $this->startDate;
    }
    /**
     * Set startDate value
     * @param \StructType\SearchDateField $startDate
     * @return \StructType\PromotionCodeSearchBasic
     */
    public function setStartDate(\StructType\SearchDateField $startDate = null)
    {
        $this->startDate = $startDate;
        return $this;
    }
    /**
     * Get customFieldList value
     * @return \StructType\SearchCustomFieldList|null
     */
    public function getCustomFieldList()
    {
        return $this->customFieldList;
    }
    /**
     * Set customFieldList value
     * @param \StructType\SearchCustomFieldList $customFieldList
     * @return \StructType\PromotionCodeSearchBasic
     */
    public function setCustomFieldList(\StructType\SearchCustomFieldList $customFieldList = null)
    {
        $this->customFieldList = $customFieldList;
        return $this;
    }
}
